package org.apache.bcel.generic;

import java.io.DataOutputStream;
import java.io.IOException;

/* loaded from: org_apache_bcel_generic.jar:org/apache/bcel/generic/GOTO.class */
public class GOTO extends GotoInstruction implements VariableLengthInstruction {
    /* JADX INFO: Access modifiers changed from: package-private */
    public GOTO() {
    }

    public GOTO(InstructionHandle target) {
        super((short) 167, target);
    }

    @Override // org.apache.bcel.generic.Instruction
    public void accept(Visitor v) {
        v.visitVariableLengthInstruction(this);
        v.visitUnconditionalBranch(this);
        v.visitBranchInstruction(this);
        v.visitGotoInstruction(this);
        v.visitGOTO(this);
    }

    @Override // org.apache.bcel.generic.BranchInstruction, org.apache.bcel.generic.Instruction
    public void dump(DataOutputStream out) throws IOException {
        super.setIndex(getTargetOffset());
        short opcode = getOpcode();
        if (opcode == 167) {
            super.dump(out);
            return;
        }
        super.setIndex(getTargetOffset());
        out.writeByte(opcode);
        out.writeInt(super.getIndex());
    }

    /* JADX INFO: Access modifiers changed from: protected */
    @Override // org.apache.bcel.generic.BranchInstruction
    public int updatePosition(int offset, int maxOffset) {
        int i = getTargetOffset();
        setPosition(getPosition() + offset);
        if (Math.abs(i) >= 32767 - maxOffset) {
            super.setOpcode((short) 200);
            short oldLength = (short) super.getLength();
            super.setLength(5);
            return super.getLength() - oldLength;
        }
        return 0;
    }
}
